\\ Copyright 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");

\\-----------------------------------------------------------------------------

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

check_exact(Hdiam(7), 17*17)

\\ Hdiam(k) == 1 mod 4
vector(20,k,k--; Hdiam(k)%4)

factor_vector(n) = concat(apply((r)->vector(r[2],i,r[1]), Vec(Col(factor(n)))));

print("squares");
for(k=1,20000,if(issquare(Hdiam(k)), print(k," ",factor_vector(Hdiam(k)))));


vector(150,k,k+=5; sqrtint(Hdiam(4*k)))

vector(100,k,k--; imag(P3_formula(k)-P8_formula(k)))

P3_sub_P8_real(k) =
{
  vector_modulo([-3/2, -1,  1/2,  2, 
                  3/2,  1, -1/2, -2],k) * 2^floor(k/2)
  + vector_modulo([ 1, 0, 0, -1,
                   -1, 0, 0,  1],k)
}
check_exact(vector(100,k,k--; P3_sub_P8_real(k)), \
            vector(100,k,k--; real(P3_formula(k)-P8_formula(k))))

P3_sub_P8_imag(k) =
{
  vector_modulo([-1/2, -2, -3/2, -1, 
                  1/2,  2,  3/2,  1],k) * 2^floor(k/2)
  + vector_modulo([0,  1,  1, 0,
                   0, -1, -1, 0],k)
}
check_exact(vector(100,k,k--; P3_sub_P8_imag(k)), \
            vector(100,k,k--; imag(P3_formula(k)-P8_formula(k))))

{
  for(k=4,30,printf("%2d  %36s %36s\n",
                   k,
                   factor_vector(abs(P3_sub_P8_real(k))),
                   factor_vector(abs(P3_sub_P8_imag(k)))));
}

check_exact(vector(100,k,k++; P3_sub_P8_real(k)^2 + P3_sub_P8_imag(k)^2), \
            vector(100,k,k++; Hdiam(k)))  /* k>=2 */

check_exact(vector(100,k,k++; gcd(P3_sub_P8_real(k), P3_sub_P8_imag(k))), \
            vector(100,k,k++; 1))
