\\ Copyright 2016, 2017, 2018, 2020 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0);
read("dragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

Fibonacci_binary = sum(i=0,20, 1/2^fibonacci(i));
nearly_equal(Fibonacci_binary, 2.41027879720786589179404)
sum(i=2,20, 1/2^fibonacci(i))*1.0     \\ i=2 starts fibonacci(2)=1,2,3,5,8,...
vector(5,i,i--; i+=2; fibonacci(i))
Fibonacci_vector = vector(50); for(i=1,20,my(f=fibonacci(i)); if(f<#Fibonacci_vector,Fibonacci_vector[f]=1));
Rpred_state_of_vector(Fibonacci_vector)
Fibonacci_vector = concat(1,Fibonacci_vector)
Rpred_state_of_vector(concat(1,Fibonacci_vector))
\\ A010056, starting 1,1,1,1,0 for n=0 as Fibonacci
\\ A192687  A005378(n) - A005379(n)
\\ fromdigits(Fibonacci_vector,2)/2^#Fibonacci_vector*1.0
\\ 0.910278797207865864038467
\\ 0.955139398603932932019233
\\ 2.41027879720786589179404 - 1.5

\\-----------------------------------------------------------------------------
print("\nKempner-Mahler");

\\   1      1    0    1  0  0  0  1
\\ b^-1 - b^-2    - b^-4      + b^-(2^3) - b^-(2^4) + b^-(2^5) - b^-(2^5)  
\\ fromdigits(KM_vector,2)

\\ fromdigits(KM_vector,2)
\\ dragon_point(fromdigits(KM_vector,2))/b^#KM_vector  * 1.0
\\ dragon_point(fromdigits([1],2))/b^#1
\\ dragon_fpoint(1/2)
\\ dragon_fpoint(fromdigits(KM_vector,2)/2^#KM_vector)
\\ dragon_fpoint(3/4) == b^-1 - b^-2

KM_sum(k) = sum(i=0,k,1/2^2^i);
KM_sum_odd(k) = sum(i=0,k,if(i%2==1,1/2^2^i));
KM_sum_even(k) = sum(i=0,k,if(i%2==0,1/2^2^i));

dragon_fpoint_of_KM_sum(k) = 1/2 + sum(i=0,k-1, (-1)^i * 1/2^2^i);
check_exact(dragon_fpoint_of_KM_sum(5), dragon_fpoint(KM_sum(5)))
check_exact(dragon_fpoint_of_KM_sum(6), dragon_fpoint(KM_sum(6)))

dragon_fpoint_of_KM_sum(k) = 1/2+ KM_sum_even(k-1) - KM_sum_odd(k-1);
check_exact(dragon_fpoint_of_KM_sum(5), dragon_fpoint(KM_sum(5)))
check_exact(dragon_fpoint_of_KM_sum(6), dragon_fpoint(KM_sum(6)))

dragon_fpoint_of_KM_sum(k) = 1/2 + sum(i=0,k-1, (-1)^i * 1/2^2^i);
check_exact(dragon_fpoint_of_KM_sum(5), dragon_fpoint(KM_sum(5)))
check_exact(dragon_fpoint_of_KM_sum(6), dragon_fpoint(KM_sum(6)))

quit

\\ binary_padded(  dragon_fpoint(KM_sum(6)) *2^128,128)
\\ binary_padded(  dragon_fpoint_of_KM_sum(6) *2^128,128)

% binary_padded(  dragon_fpoint_of_KM_sum(8) *2^256,256)
% dragon_fpoint(KM_sum(8)) == dragon_fpoint_of_KM_sum(8)

% GP-DEFINE  dragon_fpoint_of_KM_sum_b(k) = simplify(1 - sum(i=0,k-1, (-1)^i * 1/b^2^i));
% dragon_fpoint(KM_sum(8)) == dragon_fpoint_of_KM_sum_b(8)
% binary_padded(  dragon_fpoint_of_KM_sum_b(8) *2^256,256)



% binary(dragon_fpoint(turn_continued_sum)*2^128 + floor(turn_continued_sum*2^128))
% 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
% -1, -2, -4, -17, -65
%             2^4+1 2^6+1
% binary( (1/4+1/8+sum(i=1,3,1/(2^(4^i+1)))) *2^65)
% A030300 runs 0s and 1s lengths 2^n

% GP-DEFINE  binary_of_fraction(f) = {
% GP-DEFINE    (f>=0 && f<1) || error("f not a fraction");
% GP-DEFINE    is_power_of_2(denominator(f)) || error("denominator ",binary(denominator));
% GP-DEFINE    binary(numerator(f));
% GP-DEFINE  }
% binary(dragon_fpoint(KM_sum(6)) + KM_sum(4)))
% binary_of_fraction(simplify(dragon_fpoint(KM_sum(6))) + KM_sum(4))
% binary(KM_sum(6) - (1/4 + 1/8 + sum(i=1,3,1/(2^(4^i+1))))
