\\ Copyright 2014, 2015, 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

gGRtotal(x) = (1/2)/(1-x) + x/(1-x) * (b*gL(b*x) - I*gGLN(x));
check_exact(gf_terms(gGRtotal(x), length(GRtotal_samples)), GRtotal_samples)
check_exact(gf_terms(gGRtotal(x), 100), vector(100,k,my(k=k-1); GRtotal(k)))

GBN(k) = GLN(k) + GRtotal(k);
GBN_ref = GBN;
gGBN(x) = gGLN(x) + gGRtotal(x);
check_exact(gf_terms(gGBN(x), 100), vector(100,k,my(k=k-1); GBN(k)))

gGBN_ref = gGBN;
check_exact(gGBN(x), gGBN_ref(x));

read("pol-ascend.gp")
read("pol-pfrac.gp")

gGBN(x) =
{
(-1 + I)
 + (57/41 - 21/41*I)/(1 - x)
 + (1/5 - 1/5*I)/(1 + x)
 + (-2/5 - 1/5*I)/(1 - (1 - I)*x)
 + (-4/5 + 2/5*I)/(1 - (1 + I)*x)
 + ((66/41 - 20/41*I) + (62/41 + 16/41*I)*x + (62/41 + 98/41*I)*x^2)/(1 - (1 + I)*x + (4 - 4*I)*x^3)
  ;
}
check_exact(gGBN(x), gGBN_ref(x));

gGBN(x) =
{
(-1 + I)
 + (57/41 - 21/41*I)/(1 - x)
 + (1/5 - 1/5*I)/(1 + x)
 + (-2/5 - 1/5*I)/(1 - conj(b)*x)
 + (-4/5 + 2/5*I)/(1 - b*x)
 + ((66/41 - 20/41*I)
    + (62/41 + 16/41*I)*x 
    + (62/41 + 98/41*I)*x^2
   )/(1 - b*x - 2*b^3*x^3)
  ;
}
check_exact(gGBN(x), gGBN_ref(x));

pol_ascending_print(pol_partial_fractions(gB(b*x)))
pol_ascending_print(pol_partial_fractions((gB(b*x)-2)*1/(b*x)))
pol_ascending_print(pol_partial_fractions((gB(b*x)-2-4*b*x)*1/(b*x)^2))

{
  matsolve(([4, (2 + 2*I), + 8*I;
                         6, (4 + 4*I), 16*I;
                         10, (8 + 8*I), 24*I]),
           [(66/41 - 20/41*I);
            (62/41 + 16/41*I);
            (62/41 + 98/41*I)])
}

print("gGBN(x)");
pol_ascending_print(pol_partial_fractions(gGBN(x)))

print("terms");
{
pol_ascending_print(pol_partial_fractions(
  + (22/41 + 7/41*I) * gB(b*x)
  + (-63/164 - 7/164*I) * (gB(b*x)-2)*1/(b*x)
  + (29/164 - 15/164*I) * (gB(b*x)-2-4*b*x)*1/(b*x)^2
))
}
\\ {
\\ pol_ascending_print(pol_partial_fractions(
\\   + (35/41 - 28/41*I) * gB(b*x)
\\   + ( 9/41 + 42/41*I) * (gB(b*x)-2)*1/(b*x)
\\   + (-5/164 + 1/41*I) * (gB(b*x)-2-4*b*x)*1/(b*x)^2
\\ ))
\\ }

gGBN(x) =
{
  (-1 + I)
  + (57/41 - 21/41*I)/(1 - x)
  + (1/5 - 1/5*I)/(1 + x)
  + (-2/5 - 1/5*I      ) / (1 - conj(b)*x)
  + (-29/205 + 97/205*I) / (1 - b*x)

  + (22/41 + 7/41*I) * gB(b*x)
  + (-63/164 - 7/164*I) * (gB(b*x)-2)*1/(b*x)
  + (29/164 - 15/164*I) * (gB(b*x)-2-4*b*x)*1/(b*x)^2
  ;
}
print("difference");
pol_ascending_print(pol_partial_fractions(gGBN(x)-gGBN_ref(x)))
check_exact(gGBN(x), gGBN_ref(x));

GBN(k) =
{
  if(k==0,return(1));
  + (57 - 21*I)/41
  + (1 - I)/5            * (-1)^k
  - (2 + I)/5            * conj(b)^k
  + (-29 + 97*I)/205 * b^k

  + (22 + 7*I)/41      * b^k*B(k)
  - (63 + 7*I)/164 * b^k*B(k+1)
  + (29 - 15*I)/164 * b^k*B(k+2)
  ;
}
vector(7,k,k--; GBN(k))
check_exact(gf_terms(gB(b*x), 100), \
            vector(100,k,my(k=k-1); b^k*B(k)))
check_exact(gf_terms((gB(b*x)-2)*1/(b*x), 100), \
            vector(100,k,my(k=k-1); b^k*B(k+1)))
check_exact(gf_terms((gB(b*x)-2-4*b*x)*1/(b*x)^2, 100), \
            vector(100,k,my(k=k-1); b^k*B(k+2)))

check_exact(vector(100,k,my(k=k-1); GBN(k)), \
            vector(100,k,my(k=k-1); GBN_ref(k)))

GBf =
{
  + (22/41 + 7/41*I   ) 
  + (-63/164 - 7/164*I) * r
  + (29/164 - 15/164*I) * r^2
}

GRf_delta = GRf - 1/2
GBf_delta = GBf - 1/2
GRf_delta / GBf_delta
GBf_delta / GRf_delta

quit
