\\ Copyright 2016, 2017, 2018, 2019 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");


v_nfelt = 1/4*nfeltpow(cubic_nf,'x,3) - one_nfelt; \\ TS diagonal/straight
v_nfelt = [1, 0, 1/4]~;          \\ EightB_over_FourB_limit_nfelt
v_nfelt = [-4/17, 8/17, 15/34]~; \\ EightB_over_SixB_limit
v_nfelt = [-21/17, 8/17, 15/34]~; \\ EightB_over_SixB_limit_nfelt - 1
v_nfelt = [-1/2, 1, 0]~;         \\ SixB_over_FourB_limit_nfelt
v_nfelt = [-3/2, 1, 0]~;         \\ SixB_over_FourB_limit_nfelt - 1
v_nfelt = [1, 3/2, 1/2]~;        \\ L_B_r4_nfelt
v_nfelt = [1-4, 3/2, 1/2]~;      \\ L_B_r4_nfelt - 4
v_nfelt = [1/4-1, 3/8, 1/8]~;    \\ B_over_4Lsub1_limit - 1
v_nfelt = [1/4, 3/8, 1/8]~;      \\ B3_over_B4_limit
v_nfelt = [5/19, 13/19, 2/19]~;    \\ GRf slope to 1/2

\\ vector v of v[1] + v[2]*r + v[3]*r^2
v = [3/4, -1/4, 1/8];    \\ BlobR / BlobB
v = [1/4, 1/4, -1/8];    \\ BlobL / BlobB
v = [70/82, 3/82, -17/82];    \\ GRf centroid real
v = [-15/82, 14/82, -11/82];    \\ GRf centroid imag
v = [20,-5,1]/82;    \\ GJAf centroid imag
v = [57,-4,9]/82;    \\ GJAf centroid real
v = [1,0,1];
v = [0,-2,3];    \\ 1/X
v = [-3/58, 5/29, -1/58]; \\ X
v = [2,-13,9]/68; \\ Odistinct_mean_limit = 1/68*(2 - 13*r + 9*r^2);
v = [ 10/29, - 72/29, 42/29]; \\ DBnH_over_PB_limit
v = [13/29, -24/29, 14/29]; \\ DB_over_PB_limit
v = [16/29, 24/29, - 14/29]; \\ S_over_PB_limit
v = [3/29, 48/29, - 28/29]; \\ HQA_over_PB_limit
v = [-1/4, -1/2, 3/4]; \\ r2,r3 imaginary part squared
v = [-1,-1,1]; \\ LQ2_over_LQ_limit
v = [-27/19, 16/19, 2/19]; \\ HQA_over_DB_limit
v = [46/19, -16/19, -2/19]; \\ DBnH_over_DB_limit
v = [5/2, 1/2, -1]; \\ HQA_over_B_limit
v = [0,-1/2,1/2] - [5/2, 1/2, -1]; \\ 1/r - HQA_over_B_limit
v = [1/2,0,0] - [5/2, 1/2, -1]; \\ 1/2 - HQA_over_B_limit
v = [19/68,1/17,1/136]; \\ TAW_mean_limit
v = [19/68-2/5,1/17,1/136]; \\ TAW_mean_limit - 2/5
v = 1/58*[0, -1, -16, 19]; \\ OdistinctX_mean_limit
v = 1/238*[201, -6, -5]; \\ MinusRotB / ComplexBoundary
v = [1/2, -1/2, 1/4]; \\ LQ up to JA
v = [1-3/7, 1/28, -5/28]; \\ RQhalf proportion in BlobRQ
v = [-3/7, -1/28, 5/28]; \\ RQhalf proportion in BlobRQ
v = [-1, 1, 0]; \\ W(k) / L(k+1)
v = [2/7, 1/14, 3/14]; \\ JA_in_BlobRQ_nfelt
v = [1/2, -1/2, 1/4]; \\ JA / LQ
v = [8/21, -1/14, -3/14]; \\ 2/3 - JA_in_BlobRQ_nfelt

v_nfelt = sum(i=1,#v, v[i]*nfeltpow(cubic_nf,x,i-1));

print("v_nfelt = ",v_nfelt);
print_r_power(e) =
{
  if(e!=0,
     print1(" *r");
     if(e!=1,
        print1("^",e)));
}
     
{
  print("try single power of r");
  for(e=-40,40,
     my(r_pow_nfelt = nfeltpow(cubic_nf,'x,e));
     my(f=nfeltdiv(cubic_nf, v_nfelt, r_pow_nfelt));
     if(f[2]==0 && f[3]==0,
        print1("v = ",f[1]);
        print_r_power(e);
        print();
        quit());
  );
}

\\ always returning a column element, not integer 1
r_nfelt_pow(p) = if(p==0, one_nfelt, nfeltpow(cubic_nf,r_nfelt,p))

{
  print("try two powers of r");
  my(debug=0);
  for(inv=0,1,
     if(inv,print("try inverse"));
     my(v_nfelt=if(inv,nfeltdiv(cubic_nf, one_nfelt, v_nfelt), v_nfelt));
     for(spread=1,12,
        for(e1=-40,40,
           my(e2=e1+spread,
              r1_pow_nfelt = r_nfelt_pow(e1),
              r2_pow_nfelt = r_nfelt_pow(e2));
           my(m=Mat([r1_pow_nfelt, r2_pow_nfelt, v_nfelt]));
           if(debug,print(" try "e1" "e2"  r^e1="r1_pow_nfelt"  r^e2="r2_pow_nfelt," seeking ",v_nfelt));

           my(s=lindep(m));
           if(debug,print("  m="m"  solution s="s));
           if(#s==0,next());
           
           s /= -s[3];
           my(got_v = s[1]*r1_pow_nfelt + s[2]*r2_pow_nfelt);
           if(debug,print("  got_v="got_v));
           if(got_v != v_nfelt,
              print("  oops "got_v" != "v_nfelt);
              quit(1));
           print1("v = ",if(inv,"1/( ",""),s[1]);
           print_r_power(e1);
           print1("  + ",s[2]);
           print_r_power(e2);
           print(if(inv," )",""));
           \\ break(1);  \\ next spread
        );
     ));
}
