#!/usr/bin/perl -w

# Copyright 2016, 2017, 2019 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;
use Math::PlanePath::ComplexPlus 117; # v.117 for level_to_n_range()

use FindBin;
use lib $FindBin::Bin;
use lib "$FindBin::Bin/../tools";
use MyDragon 'NdragonToPlus';
use MyLineSegments;
use MyPrintwrap ':all';


my $level = 10;

print "  % generated by tools/$FindBin::Script\n";
print "  \\newcommand{\\MyLevel}{$level}\n";

my $path = Math::PlanePath::ComplexPlus->new;
my ($n_lo, $n_hi) = $path->level_to_n_range($level);

$Printwrap = 2;
printwrap("\\fill foreach \\p in {");
$Printwrap += 2;
foreach my $n_dragon ($n_lo .. $n_hi) {
  my $n_plus = NdragonToPlus($n_dragon);
  my ($x,$y) = $path->n_to_xy($n_plus);
  printwrap("($x,$y),");
}
printwrap("}");
printwrap(" { \\p +(-.5+\\MyGap,-.5+\\MyGap) rectangle +(.5-\\MyGap,.5-\\MyGap) };\n");

print "  % end generated\n";
exit 0;
