\\ Copyright 2015, 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("dragon-defines.gp");
read("geom-inertia.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

conj_real(z) = -real(z) + I*imag(z);
real_imag_transpose(z) = imag(z) + I*real(z);


HI_alpha_d = 2441/54432 + 12743/489888*I;
z = z_to_slope(HI_alpha_d) * 21969

\\ p = sqrt(C+A)/2
\\ q = sqrt(C-A)/2

p = sqrt( abs(HI_alpha_d) + real(HI_alpha_d) )/2
q = sqrt( abs(HI_alpha_d) - real(HI_alpha_d) )/2
p/q

{
check_exact(nearly_equal(p/q,
                         sqrt( sqrt(322510505/119995126272) + 2441/54432 )
                         / sqrt( sqrt(322510505/119995126272) - 2441/54432 )),
            1);
}
{
check_exact(nearly_equal(p/q,
                         sqrt( (sqrt(645021010) + 21969 )
                              /( sqrt(645021010) - 21969 ))),
            1);
}
{
check_exact(nearly_equal(p/q,
                         sqrt( (sqrt(645021010) + 21969 )^2
                              /((sqrt(645021010) - 21969 )*( sqrt(645021010) + 21969 )))),
            1);
}
{
check_exact(nearly_equal(p/q,
                         sqrt( (sqrt(645021010) + 21969 )^2 /162384049)),
            1);
}
{
check_exact(nearly_equal(p/q,
                         sqrt( (1127657971 + 43938*sqrt(645021010))
                               / 162384049 )),
            1);
}
{
check_exact(nearly_equal(p/q,
                         1/12743 * sqrt( 1127657971 + 43938*sqrt(645021010) )),
            1);
}

real(HGf) - imag(HGf)*p/q
{
check_exact(nearly_equal(real(HGf) - imag(HGf)*p/q,
                         real(HGf) -
                         imag(HGf)* 1/12743 * sqrt( 1127657971 + 43938*sqrt(645021010) )),
            1);
}
{
check_exact(nearly_equal(real(HGf) - imag(HGf)*p/q,
     305/756
     + 59/4816854 * sqrt( 1127657971 + 43938*sqrt(645021010) )),
   1);
}
check_exact(gcd(1127657971, 43938), 1)


imag(HGf) - (real(HGf)+1/3)*q/p
