#!/usr/bin/perl -w

# Copyright 2015, 2016, 2017, 2019 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.

use 5.004;
use strict;
use Math::PlanePath::DragonCurve 117; # v.117 for level_to_n_range()

use FindBin;
use lib $FindBin::Bin;
use MyDragon ':all';
use MyPrintwrap ':all';


my $max_k = 20;

print "% generated by tools/$FindBin::Script\n";
my $path = Math::PlanePath::DragonCurve->new;


my @start;
my @end;
foreach my $k (4 .. $max_k) {
  {
    my $n = BlobN($k);
    my ($x,$y) = $path->n_to_xy($n);
    push @start, "$x+I*$y";
  }
  {
    my $n = BlobN($k+1)-3;
    my ($x,$y) = $path->n_to_xy($n);
    push @end, "$x+I*$y";
  }
}

print "% GP-DEFINE  BlobStart_generated_samples = [ ",join(',',@start)," ];\n";
print "% GP-DEFINE  BlobEnd_generated_samples = [ ",join(',',@end)," ];\n";

print "% end generated\n";
exit 0;
