#!/usr/bin/perl -w

# Copyright 2014, 2015, 2017 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.

use 5.004;
use strict;
use Math::Complex;

use FindBin;
use lib $FindBin::Bin;
use MyDragon ':all';
use MyPrintwrap ':all';


$Printwrap = 2;
printwrap("% generated by tools/$FindBin::Script\n");

my $level = 6;

sub GSF_conj_num {
  my ($k) = @_;
  my $c = Math::Complex->make(10* 1/10, 10* 1/5);
  foreach (1 .. $k) {
    $c *= Math::Complex->make(0,-1);
  }
  return $c;
}
sub GSF_conj_den {
  my ($k) = @_;
  return 10 * 2**$k;
}

$Printwrap = 2;
printwrap("\\draw ");
$Printwrap = 4;
my $join = '';
foreach my $k (0 .. $level) {
  my $c = GSF_conj_num($k);
  my $x = $c->Re;
  my $y = $c->Im;
  my $d = GSF_conj_den($k);
  printwrap("$join(2/5 + $x/$d, -1/5 + $y/$d)"
            . ($k == $level ? '' : " node[my dot,name=P$k]\n"));
  $join = '--';
}
printwrap(";\n");

print "  % end generated\n";
exit 0;
