#!/usr/bin/perl -w

# Copyright 2014, 2016, 2017, 2019 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.

use 5.004;
use strict;
use Math::PlanePath::DragonCurve 117; # v.117 for level_to_n_range()

use FindBin;
use lib $FindBin::Bin;
use MyDragon ':all';
use MyPrintwrap ':all';


print "  % generated by tools/$FindBin::Script\n";

my $arms = 4;
my $path = Math::PlanePath::DragonCurve->new (arms => $arms);

foreach my $level (0 .. 3) {
  print "  \\begin{scope}[shift=(pos-$level)]\n";

  my $n_hi = 3 * 2**$level * $arms - 1;
  $Printwrap = 4;
  foreach my $n (0 .. $n_hi) {
    my $arrow = int($n/$arms) % 2 ? '<-' : '->';
    my ($x,$y) = $path->n_to_xy($n);
    my ($x2,$y2) = $path->n_to_xy($n+$arms);
    printwrap(" \\draw[$arrow] ($x,$y) -- ($x2,$y2);");
  }
  printwrap_newline();
  print "  \\end{scope}\n";
}

print "  % end generated\n";
exit 0;
