#!/usr/bin/perl -w

# Copyright 2014, 2015, 2017, 2019 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.

use 5.004;
use strict;
use Math::NumSeq::PlanePathTurn;

use FindBin;
use lib $FindBin::Bin;
use MyDragon ':all';
use MyPrintwrap ':all';


print "% generated by tools/$FindBin::Script\n";
my $seq = Math::NumSeq::PlanePathTurn->new(planepath => 'DragonCurve',
                                           turn_type => 'LSR');

print "% GP-DEFINE  turn_from_path_samples = [ ";
my $join = '';
foreach (1 .. 64) {
  my ($i,$value) = $seq->next;
  print "$join$value";
  $join = ',';
}

print " ];\n";
print "% end generated\n";
exit 0;
