#!/usr/bin/perl -w

# Copyright 2016, 2017, 2019 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;
use List::Util 'min';
use Math::PlanePath::DragonCurve 117; # v.117 for level_to_n_range()

use FindBin;
use lib $FindBin::Bin;
use lib "$FindBin::Bin/../tools";
use MyDragon '$triple_15ths_union_segs',
  'xy_to_node_name', '@dir4_to_dx','@dir4_to_dy';
use MyLineSegments;
use MyPrintwrap ':all';


print "  % generated by tools/$FindBin::Script\n";

my $conf = $triple_15ths_union_segs;
my $at_end = MyDragonConf->new
  (name => 'e at end',
   side => 0,
   segs => [ "2,0,2" ]);
$conf = $conf->union($at_end)->set_name('triples union plus end');
foreach my $bit (0,1) {
  $conf->is_subset( $conf->expand($bit) ) or die "oops";
}

{
  my $str = $conf->print_to_str;
  $str =~ s/^/  %    /mg;
  print $str;
}

$Printwrap = 2;
foreach my $seg (sort $conf->difference(MyDragonConf->initial)->segs_list) {
  my ($x,$y,$dir) = split /,/, $seg;
  my $dx = $dir4_to_dx[$dir];
  my $dy = $dir4_to_dy[$dir];
  printwrap(" \\pic at ($x,$y) [transform shape] {my expand pic={$dx,$dy}};");
}
printwrap_newline();

print "  % end generated\n";
exit 0;
