\\ Copyright 2014, 2015 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


pol_partial_fractions__quadratic_root(p) =
{
  if(poldegree(p) != 2, return(0));
  my(a = polcoeff(p,2),
     b = polcoeff(p,1),
     c = polcoeff(p,0),
     discriminant = sqr(b) - 4*a*c,
     r);
  print("quadratic ",p,"   a=",a," b=",b," c=",c," disc=",discriminant);
  if(issquare(-discriminant,&r),
     print("  root r=",(-b + I*r)/(2*a));
     (-b + I*r)/(2*a),
     0);
}
pol_partial_fractions__quadratic_root(x^2 + 1) == I || quit;
pol_partial_fractions__quadratic_root(x^2 + 4) == 2*I || quit;
pol_partial_fractions__quadratic_root(x^2 + 1/3) == 0 || quit;

        \\ if(! any_quad,
        \\    my(r = pol_partial_fractions__quadratic_root(fac));
        \\    if(r,
        \\       for(j=1,m[i,2],
        \\          listput(dens, variable(m[i,1]) - r));
        \\       r = conj(r);
        \\       for(j=1,m[i,2],
        \\          listput(dens, variable(m[i,1]) - r));
        \\       next));
           

\\-----------------------------------------------------------------------------
\\    t +                    t = h*b/(b - a)
\\      | a
\\    h +   *
\\      |  /  \
\\      | /     \
\\      |/        \
\\      *----------+---*
\\             b
\\
triangle_xbase_Ix(b,h,a) = 1/12*b*h^3;
triangle_xbase_Iy(b,h,a) = 1/12*(h*b^3 + h*a*b^2 + h*a^2*b);
triangle_xbase_Iz(b,h,a) = 1/12*(h*b^3 + h*a*b^2 + h*a^2*b + b*h^3); \\ Ix+Iy
triangle_xbase_Ixy(b,h,a) = 1/24*b^2*h^2 + 1/12*a*b*h^2;

\\ 1/24*h^2*(b-a)^2 - 1/24*t^2*h^2
\\ 1/24*h^2*(b-a)^2 - 1/24*h^4*b^2/(b - a)^2
\\
\\ if a=0 then
triangle_quadrant_Ix(b,h) = 1/12* b*h^3;
triangle_quadrant_Iy(b,h) = 1/12* h*b^3;          \\ transpose
triangle_quadrant_Iz(b,h) = 1/12*(h*b^3 + b*h^3); \\ Ix+Iy
triangle_quadrant_Ixy(b,h) = 1/24*h^2*b^2;

\\    h +                    h +                
\\      |                      |                
\\      |   z2                 |   z2     z1     
\\      |   *                  |   *------*            
\\      |  /  \                |  /    __-
\\      | / __-* z1            | / __--
\\      |/ -                   |/ -             
\\      *---------+---         *---------+---   
\\                b                      b      

z_is_first_quadrant(z) = real(z)>=0 && imag(z)>=0;
z_rotate_plus90(z) = -imag(z) + I*real(z);

wedge_in_first_apply(z1,z2, func, transpose_func) =
{
  \\ print("wedge_in_first_apply");
  \\ print("  z1 = "z1);
  \\ print("  z2 = "z2);
  if(z1==z2, error("oops, z1==z2"));
  if(! z_is_first_quadrant(z2),
     error("wedge_in_first_apply() oops, z1,z2 different quadrants"));
  if(arg(z2) < arg(z1),
     error("wedge_in_first_apply() z1,z2 not anti-clockwise: "z1"  "z2));

  if(imag(z1) == imag(z2),
     z1 = real_imag_transpose(z1);
     z2 = real_imag_transpose(z2);
     [z1,z2]=[z2,z1];
     func = transpose_func;
     \\ print("  horizontal");
     \\ print("  z1 = "z1);
     \\ print("  z2 = "z2);
    );
  my(b = complex_X_intercept(z1,z2));
  func(b,imag(z2),real(z2)) - func(b,imag(z1),real(z1));
}
wedge_in_first_Ix(z1,z2) = wedge_in_first_apply(z1,z2, triangle_xbase_Ix, triangle_xbase_Iy);
wedge_in_first_Iy(z1,z2) = wedge_in_first_apply(z1,z2, triangle_xbase_Iy, triangle_xbase_Ix);
wedge_in_first_Ixy(z1,z2) = wedge_in_first_apply(z1,z2, triangle_xbase_Ixy, triangle_xbase_Ixy);

wedge_in_first_Ix(z1,z2) =
{
  my(a=real(z2), b=imag(z2), c=real(z1), d=imag(z1));
  1/12*( -a^3*d + a^2*b*c - a^2*c*d + a*b*c^2 - a*c^2*d + b*c^3 );
}
wedge_in_first_Iy(z1,z2) =
{
  my(a=real(z2), b=imag(z2), c=real(z1), d=imag(z1));
  1/12*( -a*b^2*d - a*b*d^2 - a*d^3 + b^3*c + b^2*c*d + b*c*d^2 );
}

wedge_in_first_Ixy(z1,z2) =
{
  my(a=real(z2), b=imag(z2), c=real(z1), d=imag(z1));
  1/12*( -a^2*b*d - 1/2*a^2*d^2 + a*b^2*c - a*c*d^2 + 1/2*b^2*c^2 + b*c^2*d );
}


wedge_in_one_apply(z1,z2, func, flip) =
{
  \\ print("wedge_in_one_apply");
  \\ print("  z1 = "z1);
  \\ print("  z2 = "z2);
  \\ if(arg(z2) < arg(z1),
  \\    error("wedge_in_one_apply() z1,z2 not anti-clockwise: "z1"  "z2));

  my(mul=1);
  if(imag(z1)<0 || imag(z2)<0,
     z1=conj(z1); z2=conj(z2);
     mul*=flip;
     [z1,z2]=[z2,z1];
     \\ print("  conjugate to "z1"  "z2);
     );
  if(real(z1)<0 || real(z2)<0,
     z1=conj_real(z1); z2=conj_real(z2);
     mul*=flip;
     [z1,z2]=[z2,z1];
     \\ print("  conj real to "z1"  "z2);
     );

  \\ print("  mul "mul);
  mul*func(z1,z2);
}
wedge_in_one_Ix(z1,z2) =
{
  my(ret = wedge_in_one_apply(z1,z2, wedge_in_first_Ix, 1));
  if(ret < 0, error("Ix negative"));
  ret;
}
wedge_in_one_Iy(z1,z2) =
{
  my(ret = wedge_in_one_apply(z1,z2, wedge_in_first_Iy, 1));
  if(ret < 0, error(("Iy negative")));
  ret;
}
wedge_in_one_Ixy(z1,z2) = wedge_in_one_apply(z1,z2, wedge_in_first_Ixy, -1);

row_y_to_l(y,b,h) = floor(b-y/h*b);
row_by_sum(y,b,h, func) = my(l=row_y_to_l(y,b,h)); sum(x=0,l, func(x,y));
q_by_sum(b,h, func) = sum(y=0,h, row_by_sum(y,b,h, func));
b=100;
h=300;
q_by_sum(b,h, (x,y)->y^2)
triangle_quadrant_Ix(b,h)
q_by_sum(b,h, (x,y)->x^2)
triangle_quadrant_Iy(b,h)
q_by_sum(b,h, (x,y)->x*y)
triangle_quadrant_Ixy(b,h)
\\ 1/24*h^2*b^2   +0.0
print();

y=5;
row_by_sum(y,b,h, (x,y)->x*y)
1/2*row_y_to_l(y,b,h)^2*y *1.0
1/2*(b-y/h*b)^2*y *1.0
1/2*b^2*y - b/h*b*y^2 + 1/2*y^3/h^2*b^2   +0.0


\\-----------------------------------------------------------------------------
print();

xbase_t(b,h,a) = complex_Y_intercept(a+h*I,b);
xbase_row_y_to_l1(y,b,h,a) = floor(y/h*a);
xbase_row_y_to_l2(y,b,h,a) = floor(b - y/h*(b-a));
xbase_row_by_sum(y,b,h,a, func) =
{
  my(l1 = xbase_row_y_to_l1(y,b,h,a),
     l2 = xbase_row_y_to_l2(y,b,h,a));
  sum(x=l1,l2, func(x,y));
}
xbase_by_sum(b,h,a, func) = sum(y=0,h, xbase_row_by_sum(y,b,h,a, func));

h=100;
b=300;
a=50;
y=20;
t = xbase_t(b,h,a);
print("t=",t,"  ",h*b/(b - a));
xbase_by_sum(b,h,a, (x,y)->y^2)
triangle_xbase_Ix(b,h,a)
xbase_by_sum(b,h,a, (x,y)->x^2)
triangle_xbase_Iy(b,h,a)
xbase_by_sum(b,h,a, (x,y)->x*y)
triangle_xbase_Ixy(b,h,a)     + 0.0

print("row");
xbase_row_by_sum(y,b,h,a, (x,y)->x*y)
1/2*y*(b-(b-a)/h*y)^2 - 1/2*a^2/h^2*y^3
(1/2*b - a)*b/h^2*y^3 + (a - b)*b/h*y^2 + 1/2*b^2*y
\\ (1/2*b - a)*b/h^2*1/4*h^4 + (a - b)*b/h*1/3*h^3 + 1/2*b^2*1/2*h^2

kill(h)
kill(b)
kill(a)
kill(y)
b=1+I;

polygon_split_into_quadrants(v) =
{
  my(l = List([]));
  for(i=1,#v,
     my(z1 = vector_modulo(v,i-1),
        z2 = vector_modulo(v,i));
     listput(l, z1);
     if(imag(z1)*imag(z2) < 0,
        listput(l, complex_X_intercept(z1,z2)));
  );
  v = Vec(l);
  
  l = List([]);
  for(i=1,#v,
     my(z1 = vector_modulo(v,i-1),
        z2 = vector_modulo(v,i));
     listput(l, z1);
     if(real(z1)*real(z2) < 0,
        listput(l, I*complex_Y_intercept(z1,z2)));
  );
  Vec(l);
}

polygon_sum(v,func) = \
  sum(i=1,#v, func(vector_modulo(v,i-1), vector_modulo(v,i)));
polygon_Ix(v) = polygon_sum(v,wedge_in_one_Ix);
polygon_Iy(v) = polygon_sum(v,wedge_in_one_Iy);
polygon_Ixy(v) = polygon_sum(v,wedge_in_one_Ixy);


\\-----------------------------------------------------------------------------
