# Copyright 2014, 2015, 2016, 2017, 2018, 2019 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  See the file COPYING.  If not, see
# <http://www.gnu.org/licenses/>.


#------------------------------------------------------------------------------
# Rpred

#
# s0  *----->*      =>   *    *       s0,s1
# 1e                      \  /
#                          vv
#
#                          ^^
#                         /  \
# s1  *<-----*      =>   *    *       s4,s3
# 1o
#
# s2  *----->*      =>    *    *      s2,s1     not reached
# 2oB |                  / \  /
#     v                 v   vv
#                        \
#
#                           ^^
#                          /  \
# s3  *<-----*      =>    *    *      s6,s9
# 2eB ^                    \
#     |                     v
#                          /
#
# s4  *----->*      =>    *    *      s0,s11
# 2eA        ^             \  / \
#            |              vv   v
#                                ^
#                               /
#
#                           ^^
#                          /  \
# s5  *<-----*            *    *      s9,s7
# 2oA        |                /
#            v      =>       v
#                            ^
#                             \
#
# s6  *----->*      =>    *    *      s8,s11
# 3oB |      ^           / \  / \
#     v      |          v   vv   v
#                       ^        ^
#                        \      /
#
#                           ^^
#                          /  \
# s7  *<-----*      =>    *    *      non,non
# 3eB ^      |             \  /
#     |      v              vv
#                           ^^
#                          /  \
#
#
#
# s8  *----->*      =>    *    *      non,s3
# 3eC |                  / \  /
#     v                 v   vv
#     *<-----*          ^   ^^
#                        \ /  \
#                         *    *
#
# s9  *----->*           *    *       s4,non
# 3eA        ^            \  / \
#            |      =>     vv   v
#     *<-----*             ^^   ^
#                         /  \ /
#                        *    *
#
# s10  *<-----*     not on boundary
#      ^      |
#      |      v
#      *----->*
#
#---------------
#                           ^^
#                          /  \
# s9   *<-----*           *    *      s6,s9       s9=s3 no left touch
#      ^                   \
#      |            =>      v
#      *----->*            /
#                         *    *
#                          \  /
#                           vv
#
#                           ^^
#                          /  \
# s11  *<-----*           *    *      s9,s7       s11=s5 no left touch
#             |               /
#             v     =>       v
#      *----->*               \
#                         *    *
#                          \  /
#                           vv
#
#

our $Rpred_state_aref = [ [0,1],   # s0    1e
                          [4,3],   #       1o
                          [2,1],   # s2    2oB
                          [6,3],
                          [0,5],   # s4
                          [9,7],
                          [8,5],   # s6
                          [10,10],
                          [10,3],  # s8
                          [4,10],
                          [10,10], # non
                        ];

#------------------------------------------------------------------------------
# dTurnLeft states, not enough

our @dTurnLeft_state_table = ([ 0, 1 ],  # s00
                              [ 2, 1 ],  # 
                              [ 0, 3 ],  # 
                              [ 4, 3 ],  # 
                              [ 0, 5 ],  # 
                              [ 4, 3 ]); # 
our @dTurnLeft_state_to_d = (1,1, 2, 3,3, 4); # dTurnLeft values
our @dTurnLeft_state_to_name
  = ('00', '001ss', '001ss0', '001ss01', '1010', '10101'); 


#------------------------------------------------------------------------------
